***************************************************************************
**  EFFECTS.PRG
**  (C) Copyright 1990, Sub Rosa Publishing Inc.
**  A demonstration program provided to SR-Info and VP-Info users.
**  This program may be copied freely. If it is used in commercial code,
**  please credit the source, Sub Rosa Publishing Inc.
**
**  EFFECTS demonstrates the use of the SOUND and SCREEN commands.
**  EFFECTS is compatible with all current versions of VP-Info.
**  CAUTION: The Sub Rosa special effects package has been tested on
**  a wide range of systems. Please consult theFASTART file.
**  If you have a Noeffects command in your .SET file, this program
**  will still run, but quietly and with less flair.
**  EFFECTS moves displays between VPI-Info screens, and produces a range
**  of sounds in the process.
**
**  Bernie Melman and Sid Bursten
**  April, 1990
***************************************************************************
temp=0
cls ; clears screen
SCREEN 2 ; write to background screen 2 nothing will show
cls ; clear this screen as well
BOX 1,1,24,78 ; single line box
:color=iff(:color<>7,116,7)  ; red on grey
COLOR :color,2,2,23,77,3 ; hearts that the reason for red
SCREEN 2,3 ; copy screen 2 to screen 3
** put a smaller box of clubs inside the hearts
SCREEN 3
:color=iff(:color=7,7,112) ; black on grey
BOX 5,5,19,74 double
COLOR :color,6,6,18,73,5 ; clubs
SCREEN 3,4
** put a smaller box of diamonds inside the clubs
SCREEN 4
:color=iff(:color=7,7,116)
BOX 8,9,16,70
COLOR :color,9,10,15,69,4 ; diamonds
SCREEN 1 ; back to home screen
SCREEN t ; use tear effect to put up 1st screen
* produce a variety of sound effects while rotating the display
REPEAT 9 times varying temp
   SOUND temp
   DELAY .5
   SCREEN 2,1
   DELAY .5
   SCREEN 3,1
   DELAY .5
   SCREEN 4,1
ENDREPEAT
* now show off screen effects - all of which move screen 2 to screen 1
delay 3
cls
screen T ; Tear
delay 1
cls
screen R ; Right
delay 1
cls
screen L ; Left
delay 1
cls
screen U
delay 1
cls
screen D
delay 1
cls
delay 3
:color=iff(:color=7,7,31)
cls
? "Now watch some screen swapping with no delays and no special effects."
? "Press any key - except the escape key, please."
dummy = inkey()
perform fast
:color=iff(:color=7,7,31)
? "end of demo."
delay 2
cls
***************************************
procedure fast
repeat 10 times
screen 2,1
screen 3,1
screen 4,1
endrepeat
endprocedure; fast
